Loading...
Searching...
No Matches
Content-ID Header
MIME Headers

The Content-ID header is an unique identifier of an entity-body. More...

## Macros

#define | MSG_CONTENT_ID_INIT()
| Initializer for an msg_content_id_t structure.

## Typedefs

typedef msg_generic_t | msg_content_id_t
| Content-ID Header Structure.

## Enumerations

enum | { msg_content_id_hash }

## Functions

msg_content_id_t * | msg_content_id_init (msg_content_id_t x[1])
| Initialize an msg_content_id_t structure.
int | msg_is_content_id (msg_header_t const *header)
| Test if header object is an instance of msg_content_id_t.
msg_content_id_t * | msg_content_id_dup (su_home_t *home, msg_content_id_t const *header)
| Duplicate (deep copy) msg_content_id_t.
msg_content_id_t * | msg_content_id_copy (su_home_t *home, msg_content_id_t const *header)
| Copy an msg_content_id_t header structure.
msg_content_id_t * | msg_content_id_make (su_home_t *home, char const *s)
| Make a header structure msg_content_id_t.
msg_content_id_t * | msg_content_id_format (su_home_t *home, char const *fmt,...)))
| Make a Content-ID header from formatting result.

## Variables

msg_parse_f | msg_content_id_d
| Parse a Content-ID header.
msg_print_f | msg_content_id_e
| Print a Content-ID header.
msg_hclass_t | msg_content_id_class []
| Header class for Content-ID header.

## Detailed Description

The Content-ID header is an unique identifier of an entity-body.

The Content-ID value may be used for uniquely identifying MIME entities in several contexts, particularly for caching data referenced by the message/external-body mechanism. Its syntax is defined in [RFC2045] as follows:

Content-ID = "Content-ID" ":" msg-id
msg-id = [CFWS] "<" id-left "@" id-right ">" [CFWS]
id-left = dot-atom-text / no-fold-quote / obs-id-left
id-right = dot-atom-text / no-fold-literal / obs-id-right

## Macro Definition Documentation

## MSG_CONTENT_ID_INIT

#define MSG_CONTENT_ID_INIT | ( |  | ) |

Initializer for an msg_content_id_t structure.

A static msg_content_id_t structure must be initialized with the MSG_CONTENT_ID_INIT() macro. For instance,

msg_content_id_t msg_content_id = MSG_CONTENT_ID_INIT;
MSG_CONTENT_ID_INIT
#define MSG_CONTENT_ID_INIT()
Initializer for an msg_content_id_t structure.
Definition msg_mime_protos.h:852
msg_content_id_t
msg_generic_t msg_content_id_t
Content-ID Header Structure.
Definition msg_mime.h:63

## Typedef Documentation

## msg_content_id_t

typedef msg_generic_t msg_content_id_t

Content-ID Header Structure.

typedef struct
{
msg_common_t g_common[1]; // Common fragment info
msg_content_id_t *g_next; // Link to next header
char const *g_string; // Header value
}
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_content_id_hash | Hash of Content-ID header.

## Function Documentation

## msg_content_id_copy()

msg_content_id_t * msg_content_id_copy | ( | su_home_t * | home,
|  | msg_content_id_t const * | header )

inline

Copy an msg_content_id_t header structure.

The function msg_content_id_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  content_id = msg_content_id_copy(home, msg->msg_content_id);
  msg_content_id_copy
  msg_content_id_t * msg_content_id_copy(su_home_t *home, msg_content_id_t const *header)
  Copy an msg_content_id_t header structure.
  Definition msg_mime_protos.h:981

Returns
  The function msg_content_id_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_content_id_dup()

msg_content_id_t * msg_content_id_dup | ( | su_home_t * | home,
|  | msg_content_id_t const * | header )

inline

Duplicate (deep copy) msg_content_id_t.

The function msg_content_id_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_id = msg_content_id_dup(home, msg->msg_content_id);
  msg_content_id_dup
  msg_content_id_t * msg_content_id_dup(su_home_t *home, msg_content_id_t const *header)
  Duplicate (deep copy) msg_content_id_t.
  Definition msg_mime_protos.h:936

Returns
  The function msg_content_id_dup() returns a pointer to the newly duplicated msg_content_id_t header structure, or NULL upon an error.

## msg_content_id_format()

msg_content_id_t * msg_content_id_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-ID header from formatting result.

The function msg_content_id_format() makes a new Content-ID header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_content_id_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_content_id_init()

msg_content_id_t * msg_content_id_init | ( | msg_content_id_t | x[1] | ) |

inline

Initialize an msg_content_id_t structure.

An msg_content_id_t structure can be initialized with the msg_content_id_init() function/macro. For instance,

msg_content_id_t msg_content_id;
msg_content_id_init(&msg_content_id);
msg_content_id_init
msg_content_id_t * msg_content_id_init(msg_content_id_t x[1])
Initialize an msg_content_id_t structure.
Definition msg_mime_protos.h:869

Parameters

  x | pointer to msg_content_id_t structure

## msg_content_id_make()

msg_content_id_t * msg_content_id_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_content_id_t.

The function msg_content_id_make() makes a new msg_content_id_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_content_id_make() returns a pointer to newly maked msg_content_id_t header structure, or NULL upon an error.

## msg_is_content_id()

int msg_is_content_id | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_content_id_t.

The function msg_is_content_id() returns true (nonzero) if the header class is an instance of Content-ID header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_content_id() returns true (nonzero) if the header object is an instance of header Content-ID header and false (zero) otherwise.

## Variable Documentation

## msg_content_id_class

msg_hclass_t msg_content_id_class[]

extern

Header class for Content-ID header.

The header class msg_content_id_class defines how a Content-ID header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_content_id_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.